summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2004-05-11 19:41:23 +0000
committerJim Meyering <jim@meyering.net>2004-05-11 19:41:23 +0000
commitbcd1f744afcbb2eae3e4e45b2bb79a0cc34894c6 (patch)
treeef67bf3bee1fa5ce3d0ff3150a8ddeae468e602a
parent6202854ac23e35117001190fa77ef6085a61b3ca (diff)
downloadcoreutils-bcd1f744afcbb2eae3e4e45b2bb79a0cc34894c6.tar.xz
New test, for the above fix and today's lib/save-cwd.c improvement.
-rwxr-xr-xtests/rm/unread345
1 files changed, 45 insertions, 0 deletions
diff --git a/tests/rm/unread3 b/tests/rm/unread3
new file mode 100755
index 000000000..d42ffe00d
--- /dev/null
+++ b/tests/rm/unread3
@@ -0,0 +1,45 @@
+#!/bin/sh
+# Ensure that rm works even from an unreadable working directory.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ rm --version
+fi
+
+PRIV_CHECK_ARG=require-non-root . $srcdir/../priv-check
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+mkdir -p a/1 b c d/2 e/3 || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+cd c
+chmod u=x,go= .
+t=$pwd/$tmp
+
+# With coreutils-5.2.1, this would get a failed assertion.
+rm -r $t/a $t/b || fail=1
+
+# With coreutils-5.2.1, this would get the following:
+# rm: cannot get current directory: Permission denied
+# rm: failed to return to initial working directory: Bad file descriptor
+rm -r $t/d $t/e || fail=1
+
+test -d $t/a && fail=1
+test -d $t/b && fail=1
+test -d $t/d && fail=1
+test -d $t/e && fail=1
+
+(exit $fail); exit $fail